function [symbols] = generate_symbols(data_type)
%Generates the symbol set(symbols) to a given alphabet data type ('ABC','GreekABC','Aw')

switch data_type
    case 'ABC'
        symbols = {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'}; %English alphabet(26)
    case 'GreekABC'
        symbols = {'alpha','beta','gamma','delta','epsilon','zeta','eta',...
                   'theta','iota','kappa','lambda','mu','nu','xi','o','pi',...
                   'rho','sigma','tau','upsilon','phi','chi','psi','omega'};  %Greek alphabet(24)
    case 'Aw'
        symbols = {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',...
                   'alpha','beta','gamma','delta','epsilon','zeta','eta',...
                   'theta','iota','kappa','lambda','mu','nu','xi','o','pi',...
                   'rho','sigma','tau','upsilon','phi','chi','psi','omega'};  %English(26) + Greek alphabet(24)
    otherwise
        error('data type=?');
end