function [e,de] = sample_subspaces_ABC(num_of_comps,num_of_samples)
%Sampling from the 'ABC' dataset; number of subspaces: num_of_comps; number of samples: num_of_samples.
%
%OUTPUT:
%   e: e(:,t) is the t^th sample. size(e,2) = num_of_samples.
%   de: subspace dimensions.
%EXAMPLE:
%   e = sample_subspaces_ABC(26,1000);
%
%REFERENCE:
%   Barnabas Poczos, Andras Lorincz. Independent Subspace Analysis Using Geodesic Spanning Trees. International Conference on Machine Learning (ICML), pp. 673-680, 2005.
%
%Copyright (C) 2012 Zoltan Szabo ("http://nipg.inf.elte.hu/szzoli", "szzoli (at) cs (dot) elte (dot) hu")
%
%This file is part of the ITE (Information Theoretical Estimators) Matlab/Octave toolbox.
%
%ITE is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
%the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
%
%This software is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
%
%You should have received a copy of the GNU General Public License along with ITE. If not, see <http://www.gnu.org/licenses/>.

symbols = generate_symbols('ABC');
[e,de] = sample_subspaces_alphabet(symbols,num_of_comps,num_of_samples);
